import json

from services.rediscache import redis
from validators.chat import Message, ChatUpdate


async def notify_message(message: Message, action="create"):
    channel_name = f"message:{message["chat"]}"
    data = {"payload": message, "action": action}
    try:
        await redis.publish(channel_name, json.dumps(data))
        print(f"[services.presence] ok {data}")
    except Exception as e:
        print(f"Failed to publish to channel {channel_name}: {e}")


async def notify_chat(chat: ChatUpdate, member_id, action="create"):
    channel_name = f"chat:{member_id}"
    data = {"payload": chat, "action": action}
    try:
        await redis.publish(channel_name, json.dumps(data))
        print(f"[services.presence] ok {data}")
    except Exception as e:
        print(f"Failed to publish to channel {channel_name}: {e}")
